#ifndef CHIPCOUNTERALGORITHM_H
#define CHIPCOUNTERALGORITHM_H

#include "AnalysisAlgorithm.h"

namespace SctAnalysis {
    /**
       Algorithm for ChipCounter Test.
    */
class ChipCounterAlgorithm : public AnalysisAlgorithm {
public:
    virtual bool canAnalyze() const;
    virtual void analyze();
    virtual void loadData();
    virtual shared_ptr<SctData::TestResult> createTestResult() const;
    virtual boost::shared_ptr<AnalysisAlgorithm> clone(const TestData& testData, const string& moduleName) const throw();
    /** 
	constructor 
     */
    ChipCounterAlgorithm(const TestData& testData, const string& moduleName, const AnalysisAlgorithm& alg) throw() : AnalysisAlgorithm(testData, moduleName, alg) {}
    /** 
	destructor 
     */
    virtual ~ChipCounterAlgorithm() throw() {}
    
private:
    ChipCounterAlgorithm() {}
    static bool inMap;
    static const int NHEADER=6;
    static const int NBC=8;
    static const int NL1=4;
};
}

#endif //CHIPCOUNTERALGORITHM_H
