#ifndef SCTANALYSIS_REANALYSE
#define SCTANALYSIS_REANALYSE

#include "AnalysisAlgorithm.h"
#include <boost/shared_ptr.hpp>
#include <list>
#include <string>
#include <iostream>

namespace SctAnalysis{

class ReAnalyse{
public:
  ReAnalyse(int argc, char** argv);
  void printHelp() const;
  void print (std::ostream& os) const;
  void go();
private:
  std::string m_testName;
  std::list<double> m_testPoints;
  std::list< boost::shared_ptr<AnalysisAlgorithm> > m_algorithms;
  std::list< std::pair<long unsigned, long unsigned> > m_runScan;
  std::list< std::string > m_modules;
  int verbosity;
  bool m_option_n;
};

} // namepace SctAnalysis
#endif
