#ifndef QUICKCHARACTERIZATIONSEQUENCE_H
#define QUICKCHARACTERIZATIONSEQUENCE_H

#include "../ipc/SequenceRequest.h"
#include "../ipc/TestRequest.h"
#include "../ipc/CalibrationController.h"
#include "../ipc/TestLibrary.h"
#include "../ipc/CalibrationController.hh"
#include "Sct/OmniMarshalling.h"
#include <iostream>

using namespace std;

namespace SctCalibrationController {
    
using namespace Ipc;

namespace Scripts {
    
class QuickCharacterizationSequence : public SequenceRequestImpl {
public:	
    static Sct_CalibrationController::SequenceRequest_ptr instance() {
	    static QuickCharacterizationSequence cs;
	    return cs._this();
    }
    
    virtual char * startSequence(Sct_SctApi::SctApiIPC_ptr api) {
        this->api = Sct_SctApi::SctApiIPC::_duplicate(api);
        return ::Sct::copyStringToCorba("QuickCharacterizationSequence");
    }
    
    virtual Sct_CalibrationController::TestRequest_ptr getNextTest(unsigned long index) {
	Sct_CalibrationController::TestLibrary_var tl = CalibrationControllerImpl::instance()->getTestLibrary();
	switch (index) {
	case 0:
          return tl->getTestRequestByName("NMask"); // These lines need changing to &tl.getTestRequestByName("NMask"); etc
	case 1:
#warning Only Barrel combinations of bypass included in characterization sequence
	    return tl->getTestRequestByName("FullBypassBarrel");	  // These lines need changing to &tl.getTestRequestByName("NMask"); etc  
	case 2:
	    return tl->getTestRequestByName("Pipeline");// These lines need changing to &tl.getTestRequestByName("NMask"); etc
	case 3:
	    return tl->getTestRequestByName("StrobeDelay");// These lines need changing to &tl.getTestRequestByName("NMask"); etc
	case 4:
	    return tl->getTestRequestByName("ThreePointGain");// These lines need changing to &tl.getTestRequestByName("NMask"); etc
        case 5:
            return tl->getTestRequestByName("QuickTrimRange");// These lines need changing to &tl.getTestRequestByName("NMask"); etc
	case 6:
	    return tl->getTestRequestByName("FivePointGain");// These lines need changing to &tl.getTestRequestByName("NMask"); etc
	case 7:
	    return tl->getTestRequestByName("NoiseOccupancy");// These lines need changing to &tl.getTestRequestByName("NMask"); etc
	case 8:
	    return tl->getTestRequestByName("TimeWalk");// These lines need changing to &tl.getTestRequestByName("NMask"); etc
	default:
	    return Sct_CalibrationController::TestRequest::_nil();
	}
    }
    
    virtual void endSequence() {
	api = Sct_SctApi::SctApiIPC::_nil();
    }     
    
private:
    Sct_SctApi::SctApiIPC_var api;
    QuickCharacterizationSequence() {}
};
}
}
#endif //QUICKCHARACTERIZATIONSEQUENCE_H
