
#ifndef LESTER_LARGECARROT_H
#define LESTER_LARGECARROT_H

#include "Rabbit.hh"
#include <ipc/object.h>
#include <ipc/server.h>
#include <vector>
#include "LargeOnion.h"

class LargeCarrot :
 public IPCNamedObject<POA_Stew::Carrot, ipc::multi_thread>, // The important part.
 public IPCServer {                // We fancy calling a blocking "run()" method or and unblocking "stop()" method.
  
 public:
  LargeCarrot() : 
    IPCNamedObject<POA_Stew::Carrot, ipc::multi_thread>(IPCPartition("SCT"),
                                                        "LargeCarrotName") {
    m_gobble = new std::vector<int>(1000000);
    (*m_gobble)[976424]=234;
    std::cout << "Publishing LargeCarrot ..." << std::endl;
    publish();
  };

 public:
  virtual Stew::Onion_ptr anOnion() {
    static LargeOnion largeOnion;
    return largeOnion._this();
  };
  
 public:
  virtual void shutdown() {
    std::cout << "I was asked to shut my LargeCarrot down!" << std::endl;
    stop();
  };

 public:
  ~LargeCarrot() {
    std::cout << "~LargeCarrot()" << std::endl;
    delete m_gobble;
  };

 private:
  std::vector<int> * m_gobble;

};

#endif 
