

#include "LargeTemporaryReturnType.h"
#include <ipc/core.h>
#include <unistd.h>

void sl(const unsigned int s) {
    std::cout << "Sleeping for " << s << " seconds" << std::endl;
    sleep(s);
};

void createATemporaryReturnTypeAndDoStuff() {
  std::cout << "Making a temporaryreturntype ..." << std::endl;
  LargeTemporaryReturnType & largeTemporaryReturnType = *(new LargeTemporaryReturnType); // not supposed to do "LargeCarrot largeCarrot;" as this can lead to largeCarrot being deleted twice -- once when largeCarrot goes out of scope, and once if/when someone remotely requests it be deleted.".  For this reason, we are equally only supposed to delete it with _destroy();
  std::cout << "... finishing making a temporaryreturntype" << std::endl;
  sl(1);
  {
    // get a reference to the temporaryreturntype object
    std::cout << "Getting a reference to the temporaryreturntype object" << std::endl;
    Stew::TemporaryReturnType_var temporaryreturntype = largeTemporaryReturnType._this();
    sl(1);
  };

  {
    // get a different reference to the temporaryreturntype object
    std::cout << "Getting a different reference to the temporaryreturntype object" << std::endl;
    Stew::TemporaryReturnType_var temporaryreturntype = largeTemporaryReturnType._this();
    sl(1);

    std::cout << "Calling endLifeOfServant on the reference" << std::endl;
    temporaryreturntype->deleteServant(); // we implemented this method so that it would end the life of the servant.
    // it is vital we call shutdown for this temporary object otherwise we will leak memory.
    sl(1);
  };
  
};

int main(int argc, char * argv[]) {
  std::cout << "This program demonstrates how to use an object that will live only for a short time (eg a return type) that will not be published in the IPC::Partition index." << std::endl;
  std::cout << "Initialising IPC ..." << std::endl;
  IPCCore::init(argc, argv);

  // create the server for a TemporaryReturnType object
  createATemporaryReturnTypeAndDoStuff();

  std::cout << "Bye" << std::endl;
};
