
#include "ApplicationStartupDebugTools.h"
#include "SctNames.h"
#include "URandom.h"
#include <iostream>
#include <unistd.h>
#include <mrs/message.h>

namespace Sct {

  std::string ApplicationStartupDebugTools::programArgs(const int argc,
                                                        const char * const * const argv) {
    std::ostringstream os;
    if (argv) {
      bool first=true;
      for (int i=0; i<argc; ++i) {
        if (argv[i]) {
          if (first) {
            first=false;
          } else {
            os << " ";
          };
          os << argv[i];
        };
      };
    };
    return os.str();
  };

  void ApplicationStartupDebugTools::announceStartOfMain(const int argc, // make me and the next arg 0 if you don't have access to us!
                                                         const char * const * const argv,
                                                         const std::string & file,
                                                         const unsigned int line,
                                                         const std::string & message,
                                                         unsigned int delaySeconds) {
    
    const bool announceToMrsIfAvailable = true;
    const bool announceToStdOut = true;
    const bool announceToSomewhere = announceToMrsIfAvailable || announceToStdOut;

    if (delaySeconds==0 && false) {
      delaySeconds = (URandom::urand<unsigned int>() & 7) + 1; // 1 to 8 seconds delay
    };

    const bool delayThings = (true && delaySeconds>0);

    const std::string progArgs = announceToSomewhere?programArgs(argc,argv):"";
    
    if (announceToSomewhere) {
      std::ostringstream os;
      os << "ApplicationStartupDebugTools::announceStartOfMain called by ["
         <<progArgs<<"] in File["<<file<<"] at Line["<<line
         <<"] with additional Message["<<message<<"].";
      if (delayThings) {
        os << " There will now be a delay of " << delaySeconds << " seconds.";
      };
      
      const std::string messageString = os.str();

      if (announceToMrsIfAvailable) {
        IPCPartition p(SctNames::getPartitionName());
        if(p.isValid()) {
          MRSStream mrs(p);
          mrs << MRS_INFORMATION << "AppStartupDbgTools" << MRS_TEXT(messageString) << ENDM;
        };
      };

      if (announceToStdOut) {
        std::cout << "AppStartupDbgTools: ["<< messageString << "]" << std::endl;
      };

    };
      
    if (delayThings) {
      sleep(delaySeconds);
    };

    if (announceToSomewhere && delayThings) {
      std::ostringstream os;
      os << "Endo of delay for announceStartOfMain called by ["<<progArgs<<"]";
      
      const std::string messageString = os.str();

      if (announceToMrsIfAvailable) {
        IPCPartition p(SctNames::getPartitionName());
        if(p.isValid()) {
          MRSStream mrs(p);
          mrs << MRS_INFORMATION << "AppStartupDbgTools" << MRS_TEXT(messageString) << ENDM;
        };
      };
      
      if (announceToStdOut) {
        std::cout << "AppStartupDbgTools: ["<< messageString << "]" << std::endl;
      };
    };

    
  };
  
};
