
//////////////////////////////////////////////////////////////////////
///////////////////////// RefCountServantBase ////////////////////////
//////////////////////////////////////////////////////////////////////

#include "RefCountServantBase.h"

Sct::RefCountServantBase::~RefCountServantBase() {}


void Sct::RefCountServantBase::_sct_add_ref()
{
  boost::mutex::scoped_lock lk(this->m_mutex);
  // If the reference count is 0, then the object is either in the
  // process of being deleted by _remove_ref, or has already been
  // deleted. It is too late to be trying to _add_ref now. If the
  // reference count is less than zero, then _remove_ref has been
  // called too many times.
  //OMNIORB_USER_CHECK(pd_refCount > 0);

  pd_refCount++;
}


void Sct::RefCountServantBase::_sct_remove_ref() {
  
  int done;
  {
    boost::mutex::scoped_lock lk(this->m_mutex);
    done = --pd_refCount > 0;
  };
  
  if( done )  return;
  
  if( pd_refCount < 0 ) {
    //omniORB::logs(1, "RefCountServantBase has negative ref count!");
    return;
  }

  //omniORB::logs(15, "RefCountServantBase has zero ref count -- deleted.");

  // The PortableServer::RefCountServantBase calls delete this, but we want to be more flexible, so:
  this->performCountEqualsZeroAction();
}

