#ifndef SCTAPIIPC_SEQUENCEUTILS_H
#define SCTAPIIPC_SEQUENCEUTILS_H

namespace Sct {
	
class SequenceUtils {
 public:

  template<class SequenceType>
    static SequenceType * newSafeSequence(unsigned int length) {
    SequenceType * ans = new SequenceType(length); // sets MAX length, but doesn't allocate memory.
    ans->length(length); // allocates memory
    return ans;
  };

  template<class SequenceType>
    static SequenceType safeSequence(unsigned int length) {
    SequenceType ans(length); // sets MAX length, but doesn't allocate memory.
    ans.length(length); // allocates memory
    return ans;
  };
  
};

};

#endif
