
#ifndef SCT_TOKENIZE_H
#define SCT_TOKENIZE_H

#include <string>
#include <vector>
#include <list>

namespace Sct {

  class Tokenize {
  public:
    typedef std::list<std::string> Tokens;
  private:
    Tokens m_tokens;
  public:
    typedef std::list<std::string> Tokens;
    typedef std::vector<std::string> TokenVec;
    Tokenize(const std::string& str,
	     const std::string& delimiters = " ");
    Tokens::const_iterator begin() const {
      return m_tokens.begin();
    };
    Tokens::const_iterator end() const {
      return m_tokens.end();
    };
    Tokens::iterator begin() {
      return m_tokens.begin();
    };
    Tokens::iterator end() {
      return m_tokens.end();
    };
    const Tokens & tokens() const {
      return m_tokens;
    };
    TokenVec tokenVec() const;
    Tokens & tokens() {
      return m_tokens;
    };
    unsigned int size() const {
      return m_tokens.size();
    };
    bool empty() const {
      return m_tokens.empty();
    };
  };

};

#endif
