#include "ChipCounterTestResult.h"
#include "NullVariable.h"
#include "DefaultVariable.h"
#include <CommonWithDsp/ABCD/ABCDscans.h>

///@todo check that ST_COMPRESSION is really the right variable!

namespace SctData{
  
  const std::string rangedVectorName = "ChipCounterStreamResult";

  ChipCounterTestResult::ChipCounterTestResult() throw() : streamResults(rangedVectorName) {
    streamResults.resize(nLinkModule);
  }
    
  ChipCounterTestResult::ChipCounterTestResult(unsigned int runNumber, const string& moduleName) throw()
    : TestResult(runNumber, moduleName, NullVariable::instance(), 
                 *DefaultVariable::instance(ST_COMPRESSION)), 
      streamResults(rangedVectorName){
    streamResults.resize(nLinkModule);
  }
    
  ChipCounterTestResult::~ChipCounterTestResult() throw() {}

  string ChipCounterTestResult::getClassName() const throw(){
    return string("SctData::ChipCounterTestResult");
  }

  const ChipCounterTestResult::StreamResult& ChipCounterTestResult::getStreamResult(const unsigned index) const{
    return streamResults[index];
  }
    
  ChipCounterTestResult::StreamResult& ChipCounterTestResult::getStreamResult(const unsigned index){
    return streamResults[index];
  }

}
