#ifndef CHIPCOUNTERTESTRESULT_H
#define CHIPCOUNTERTESTRESULT_H

#include "TestResult.h"
#include "Sct/RangedVector.h"

namespace SctData{
  /**
     The class represents the result of a ChipCounter test.	
     @author Bilge Demirkoz
  */
  class ChipCounterTestResult : public TestResult {
  public:
    ChipCounterTestResult() throw();
	
    /**
       Constructor.
    */
    ChipCounterTestResult(unsigned int runNumber, const string& moduleName) throw();
	
    /**
       Destructor
    */
    virtual ~ChipCounterTestResult() throw();
	
    //Override
    virtual string getClassName() const throw();

    class StreamResult {
    public:
    private:
    };
	
    /**
       get StreamResult @param index stream in range 0->1 
    */
    StreamResult& getStreamResult(const unsigned index);
    /**
       const get StreamResult @index stream in range 0->1
    */
    const StreamResult& getStreamResult(const unsigned index) const;
  private:
    RangedVector<StreamResult> streamResults;
    
  };
}// end of namespace SctData
#endif 
