#include "MarkSpaceRatioTestResultStreamer_v1.h"

using namespace Sct;

namespace SctData {
    namespace IO {

/* READ NOTES ON STREAMERS AND VERSIONS BEFORE EDITING THIS FILE! */
unsigned MarkSpaceRatioTestResultStreamer_v1::s_version=1;

	MarkSpaceRatioTestResultStreamer_v1::MarkSpaceRatioTestResultStreamer_v1() throw() {}
	
bool MarkSpaceRatioTestResultStreamer_v1::inMap = IOManager::addToMap("SctData::MarkSpaceRatioTestResult",  auto_ptr<Streamer>(new MarkSpaceRatioTestResultStreamer_v1()));
	
	shared_ptr<Streamable> MarkSpaceRatioTestResultStreamer_v1::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError){
	    boost::shared_ptr<Streamable> ad (new MarkSpaceRatioTestResult());
	    read(in, *ad, manager);
	    return ad;
	}
	
	void MarkSpaceRatioTestResultStreamer_v1::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
	    //Let superclass do its work
	    manager.writeImpl(out, ob, "SctData::TestResult");
	    
	    //cout << "MarkSpaceRatioTestResultStreamer_v1 doing dynamic_cast" << endl;
	    const MarkSpaceRatioTestResult& mytest = dynamic_cast<const MarkSpaceRatioTestResult&>(ob);
	    out << mytest.getOptimum();
	    out << mytest.getNPoints();
	    for (unsigned i=0; i<mytest.getNPoints();++i){
	      const MarkSpaceRatioTestResult::MsrPoint& p=mytest.getPoint(i);
	      out << p.occ0 << p.occ1 << p.occ0flip << p.occ1flip << p.msr;
	    }
	}
	
	void MarkSpaceRatioTestResultStreamer_v1::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
	    manager.readImpl(in, ob, "SctData::TestResult");
	    
	    MarkSpaceRatioTestResult& mytest = dynamic_cast<MarkSpaceRatioTestResult&>(ob);
	    double optimum;
	    in >> optimum;
	    mytest.setOptimum(optimum);
	    unsigned npoints;
	    in >> npoints;
	    for (unsigned i=0; i<npoints; ++i){
	      MarkSpaceRatioTestResult::MsrPoint p;
	      in >> p.occ0 >> p.occ1 >> p.occ0flip >> p.occ1flip >> p.msr;
	      mytest.addPoint(p);
	    }
	}
    } 
}
