#include "MarkSpaceRatioTestResult.h"
#include "NullVariable.h"
#include "DefaultVariable.h"
#include <CommonWithDsp/ABCD/ABCDscans.h>

///@todo check that ST_COMPRESSION is really the right variable!

namespace SctData{
  string MarkSpaceRatioTestResult::vector_name("MarkSpaceRatio:msr_result");

  MarkSpaceRatioTestResult::MarkSpaceRatioTestResult() throw() : msr_result(vector_name) {
  }
    
  MarkSpaceRatioTestResult::MarkSpaceRatioTestResult(unsigned int runNumber, const string& moduleName) throw()
    : TestResult(runNumber, moduleName, NullVariable::instance(), *DefaultVariable::instance(ST_ELAPSED)),
      msr_result(vector_name)
  {
  }
    
  MarkSpaceRatioTestResult::~MarkSpaceRatioTestResult() throw() {}

  string MarkSpaceRatioTestResult::getClassName() const throw(){
    return string("SctData::MarkSpaceRatioTestResult");
  }

  void MarkSpaceRatioTestResult::addPoint(const MsrPoint& r) {
    msr_result.push_back(r);
  }
  
  unsigned MarkSpaceRatioTestResult::getNPoints() const {
    return msr_result.size();
  }
  
  MarkSpaceRatioTestResult::MsrPoint MarkSpaceRatioTestResult::getPoint(unsigned index) const{
    return msr_result[index];
  }
  
  double MarkSpaceRatioTestResult::getOptimum() const {
    return optimum;
  }

  void MarkSpaceRatioTestResult::setOptimum(double o) {
    optimum=o;
  }
  
  double MarkSpaceRatioTestResult::MsrPoint::getOccupancy(unsigned ilink) const{
    return ilink ? occ1 : occ0;
  }  

  double MarkSpaceRatioTestResult::MsrPoint::getOccupancyFlipped(unsigned ilink) const{
    return ilink ? occ1flip : occ0flip;
  }

}
