#ifndef RXTHRESHOLDTESTRESULT_H
#define RXTHRESHOLDTESTRESULT_H

#include "SingleVariableTestResult.h"

using namespace std;

namespace SctData {
	
  /**
   * A derived class of TestResult, containing the results data for a Rx Threshold Test.
   * Such a test requires only a single scan.<P>
   * The result of the analysis is an optimum delay value for each of the 12 chips.
   * @author Alan Barr
   */
class RxThresholdTestResult : public SingleVariableTestResult {
public:
    RxThresholdTestResult() throw();

    ~RxThresholdTestResult() throw() {}
    
    /**
    Constructor.  
    */
    RxThresholdTestResult(const unsigned int runNumber, const string& moduleName) throw() ;
      
    //override
    virtual string getClassName() const throw() ;
  
};
  
} // end of namespace SctData

#endif //#ifndef RXTHRESHOLDTESTRESULT_H
