
#ifndef SCT_SCTAPI_IDIOSYNCRASY_H
#define SCT_SCTAPI_IDIOSYNCRASY_H

/// The Idiosyncrasy is a something sufficient source of information to
/// allow one SctApi on one crate to differentiate itself from
/// another SctApi on another crate.

/// Should probably move this out of SctApi pacakge and into SCT/src as this doesn't depend on anything in SctApi.

//fwd dec
namespace SctApi {
  class Idiosyncrasy;
};

//other fwd decs

//other includes
#include <string>
#include "Sct/Addressing.h"

//dec
namespace SctApi {
  class Idiosyncrasy {
    const Sct::UCID m_ucid;
    mutable std::string m_uniqueName;
    mutable std::string m_infoServiceNameOfScanStatusObject;
    mutable std::string m_ipcNameOfSctApiCrateServer;
  public:
    Idiosyncrasy(const Sct::PartitionIdentifier p,
		 const Sct::CrateIdentifier c);
    explicit Idiosyncrasy(const Sct::UCID & ucid);
    const std::string & uniqueName() const; // a component from which other parts may be built
    const std::string & ipcNameOfSctApiCrateServer() const;
    const std::string & infoServiceNameOfScanStatusObject() const;
    // uniqueCrateIdentifier
    const Sct::UCID & ucid() const;
  };
};

#endif
