#ifndef SCTAPIIPC_LOCALUTILS_H
#define SCTAPIIPC_LOCALUTILS_H

static Sct_SctApi::SctApiException myRaise( ::SctApi::SctApiException &s);
static inline SctApi::BankType myTranslateBank(Sct_SctApi::BankType bank);

Sct_SctApi::SctApiException myRaise( ::SctApi::SctApiException &c) 
{
  cout << "Raising exception " << c.what() << endl;
  return Sct_SctApi::SctApiException(c.what());
}


SctApi::BankType myTranslateBank(Sct_SctApi::BankType bank) {

  SctApi::BankType result;
  switch(bank) {
  case Sct_SctApi::PHYSICS_CONFIG:
    result = ::SctApi::SCTAPI_BANK_PHYSICS;
    break;
  case Sct_SctApi::CALIBRATION_CONFIG:
    result = SctApi::SCTAPI_BANK_CALIBRATION;
    break;
  case Sct_SctApi::SCAN_CONFIG:
    result = SctApi::SCTAPI_BANK_SCAN;
    break;
  default:
    result = SctApi::SCTAPI_BANK_PHYSICS;
    break;
  }
  return result;
}

static inline
std::list<SctApi::BankType> myTranslateBanks(const Sct_SctApi::BankList& banks){
  std::list<SctApi::BankType> copied;
  for (unsigned i=0; i<banks.length(); ++i){
    copied.push_back(myTranslateBank(banks[i]));
  }
  return copied;
}
#endif
