#include "sctConfIPC/configuration.hh"
#include <ipc/core.h>
#include <ipc/server.h>
#include <ipc/object.h>
#include <ipc/partition.h>
#include <iostream>

int main(int argc, char** argv) {
  IPCCore::init(argc,argv);

  IPCPartition p("SCT");

  sctConf::Configuration_var handle = 
    p.lookup<sctConf::Configuration>(sctConf::Configuration::instanceName);

  if (CORBA::is_nil(handle) ) {
    std::cout << "Error - handle was nil" << std::endl;
    return -1;
  }
  
  sctConf::PartitionList* myList = handle->listPartitions();
  std::cout << "Done get partition\n";

  unsigned long barrel, row;
  long number;
  
  handle->translateToBarrel(0, 1, barrel, row, number);

  for(unsigned int i=0; i<myList->length(); i++) {
    std::cout << i << " " << (*myList)[i] << std::endl;
  }

  handle->saveConfiguration("config_client_dump.xml");
}
