/*
 * DDCModuleSwitcher.java
 *
 * Created on 03 March 2005, 13:50
 */

package DisplayGUI;
import java.util.*;
import GuiComponents.System.*;
import Sct_SctApi.*;
import Sct_SctApi.SctApiDDCServer;
import java.awt.event.*;

/**
 *
 * @author  robinson
 */
public class DDCModuleSwitcher extends javax.swing.JFrame implements displayParams,ActionListener {


    private javax.swing.JButton jButton1,jButton2,jButton3;
    private javax.swing.JComboBox jComboBox1,jComboBox2, jComboBox3;
    private javax.swing.JLabel jLabel1,jLabel2,jLabel3,jLabel4,jLabel5,jLabel6;
    String serialno;
    Vector moduleList;
    int sctView;

    /** Creates new form test */
    public DDCModuleSwitcher(int sctView, String serialno) {
        super("Module HV/LV Control");
	this.serialno=serialno;
	this.sctView=sctView;
	this.moduleList=new Vector(ConfigurationInterface.getInstance().getSortedVector(sctView));
        initComponents();
    }

    public DDCModuleSwitcher(int sctView) {
        super("Module HV/LV Control");
	this.serialno=null;
	this.sctView=sctView;
	this.moduleList=new Vector(ConfigurationInterface.getInstance().getSortedVector(sctView));
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
       
        java.awt.GridBagConstraints gridBagConstraints;

        jButton2 = new javax.swing.JButton();
        jButton2.setFont(displayTextFont);
        jComboBox1 = new javax.swing.JComboBox(moduleList);
        jComboBox1.setFont(displayTextFont);
        jComboBox1.setBackground(backgroundColor);
        jComboBox1.insertItemAt("All Modules",0);
	if(serialno!=null) jComboBox1.setSelectedItem(serialno);
	else jComboBox1.setSelectedIndex(0);
	jComboBox1.addActionListener(this);

        jComboBox2 = new javax.swing.JComboBox();
        jComboBox2.setFont(displayTextFont);
        jComboBox2.setBackground(backgroundColor);
	jComboBox2.addItem("OFF");
	jComboBox2.addItem("ON");
	
        jComboBox3 = new javax.swing.JComboBox();
        jComboBox3.setFont(displayTextFont);
        jComboBox3.setBackground(backgroundColor);
	jComboBox3.addItem("LV");
	jComboBox3.addItem("HV");


        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
	jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
	jLabel6 = new javax.swing.JLabel();

        jButton1 = new javax.swing.JButton();
        jButton1.setFont(displayTextFont);
        jButton3 = new javax.swing.JButton();
        jButton3.setFont(displayTextFont);

        getContentPane().setLayout(new java.awt.GridBagLayout());

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jComboBox1, gridBagConstraints);

        jLabel1.setText("Module LV and HV Control");
        jLabel1.setFont(displayTitleFont);
	jLabel1.setForeground(darkBlueColor);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
	gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.CENTER;
        gridBagConstraints.weighty = 0.1;
        getContentPane().add(jLabel1, gridBagConstraints);
	
        jLabel2.setText("Module(s):");
        jLabel2.setFont(displayTextFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.weighty = 0.2;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jComboBox1, gridBagConstraints);
	
        jLabel3.setText("Crate/Channel:");
        jLabel3.setFont(displayTextFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jLabel3, gridBagConstraints);
	
        jLabel4.setText("All active Crates/Channels");
        jLabel4.setFont(displayTextFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.weighty = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
	jLabel4.setForeground(darkGreenColor);
        getContentPane().add(jLabel4, gridBagConstraints);
	
        jLabel5.setText("State:");
        jLabel5.setFont(displayTextFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jLabel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.weighty = 0.2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jComboBox2, gridBagConstraints);

        jLabel6.setText("Type:");
        jLabel6.setFont(displayTextFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jLabel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.weighty = 0.2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jComboBox3, gridBagConstraints);

	jButton1.setText("Ok");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        getContentPane().add(jButton1, gridBagConstraints);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {

		  Sct_SctApi.SctApiDDCServer api = SystemInterface.getInstance().getSctApiDDCServer();
		  if(api==null) {
		    javax.swing.JOptionPane.showMessageDialog(null,"null SctApi pointer");
		    return;
		    }
		    
		  int state = 8;                         //LV Off=9, LV ON=6 HV off=9, HV on=7
		  if(jComboBox2.getSelectedIndex()==0) { // OFF state
		      state = (jComboBox3.getSelectedIndex()==0) ? 8 : 9;
		      }
		  else {                                 // ON state
                      state = (jComboBox3.getSelectedIndex()==0) ? 6 : 7;
		      }
		      

		   java.util.Set crateSet = new java.util.HashSet();
		   ConfigurationInterface conf = ConfigurationInterface.getInstance();
		   try {
		       if(jComboBox1.getSelectedIndex()==0) { //all modules
                          for(java.util.Enumeration e = conf.getSerialNumberMap(sctView).elements(); e.hasMoreElements();) {
                              ModuleCell thisCell = (ModuleCell) e.nextElement();
                              String sn = thisCell.getSerialNo();
			      int moduleGroup = thisCell.getModuleGroup();
			      moduleGroup++;
			      String grCmd = "gr"+Integer.toString(moduleGroup);
		          // for (int i=0;i<moduleList.size();i++) {
			 //    String sn=(String)moduleList.elementAt(i);
			     String crate = conf.getSNInfo(sn,SNInfo.DCS_CRATE);
			     if(crate.equals("-1")) continue;
			     if(crateSet.contains(crate+grCmd)) continue;
			     System.out.println("sctGUI - switching group "+Integer.toString(moduleGroup)+" module(s) in crate "+crate+" to state "+Integer.toString(state));
			     crateSet.add(crate+grCmd);
                             api.ddcChangeStates(Integer.valueOf(crate).intValue(),grCmd,(short)state);
			     }
                           System.out.println("sctGUI - all crate power switching completed.");
	                }
                       else {  // single module
		          String sn = (String)jComboBox1.getSelectedItem();
			  String crate = conf.getSNInfo(sn,SNInfo.DCS_CRATE);;
			  String channel = conf.getSNInfo(sn,SNInfo.DCS_CHANNEL);
			  System.out.println("Switching module "+sn+" (crate/channel "+crate+","+channel+") to state "+Integer.toString(state));
			  api.ddcChangeStates(Integer.valueOf(crate).intValue(),channel,(short)state);
                          System.out.println("Completed.");
			  }
                     }catch(Exception e){javax.swing.JOptionPane.showMessageDialog(null,"Exception "+e.toString());}

		     }
             });

        jButton2.setText("Close");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHEAST;
        gridBagConstraints.weighty = 0.1;
        getContentPane().add(jButton2, gridBagConstraints);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
                 public void actionPerformed(java.awt.event.ActionEvent evt) {
                     exitForm(null);
                     }
             });
        getContentPane().setBackground(new java.awt.Color(255, 255, 255));
	
	if(serialno!=null) setLabel(serialno);


        pack();
	show();
    }

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
       setVisible(false);
       dispose();
    }
    
   public void actionPerformed(ActionEvent e) {
        javax.swing.JComboBox cb = (javax.swing.JComboBox)e.getSource();
	if(cb.getSelectedIndex()==0) {
	   jLabel4.setText("All active Crates/Channels");
	   return;
	   }
        String sn = (String)cb.getSelectedItem();
	setLabel(sn);

    }
    
 private void setLabel(String sn) {
	ConfigurationInterface conf = ConfigurationInterface.getInstance();
	String crate = conf.getSNInfo(sn,SNInfo.DCS_CRATE);
	String channel = conf.getSNInfo(sn,SNInfo.DCS_CHANNEL);
	jLabel4.setText("Crate "+crate+", Channel "+channel);
	}






}
