package DisplayGUI;

public class MURInfo {
    String[] serialnos = new String[6];
    java.io.File murFile;
    String murID;
    String[][] rxThrMap = new String[2][];
    String[][] newRxThrMap = new String[2][];
    java.util.Map snMap = new java.util.HashMap();
    boolean update;

    public MURInfo(String murID, java.io.File file) {
       this.murID=murID;
       murFile=file;
       update=false;
       for(int i=0;i<2;i++) {
          rxThrMap[i]=new String[6];
          newRxThrMap[i]=new String[6];
	  }
        }
    public void addModule(String id, String sn) {
       try {
          int thisID = (Integer.valueOf(id)).intValue();
	  thisID--; // id is 1 to 6!
	  serialnos[thisID] = sn;
	  snMap.put(sn,id);
	  }catch(Exception e) {
	    System.err.println("**Exception non-integer id for serialno "+sn+" in MUR "+murID);
	    System.err.println("id="+id+" sn="+sn);
	    }
	}
    public java.io.File getXMLFile() {
       return murFile;
       }
    public boolean containsModule(String id) {
       try {
          int thisID = (Integer.valueOf(id)).intValue();
	  thisID--; // thisID is 1 to 6
	  return (serialnos[thisID]!=null);
	  }catch(Exception e) {}
       return false;
       }

    public void addThr(String id, int stream, String data, boolean isUpdate) {
       int thisID=-1;
       try {
          thisID = (Integer.valueOf(id)).intValue();
	  thisID--; // thisID is 1 to 6
	  }catch(Exception e) {}
       if(thisID==-1) {
          System.err.println("Invalid id in MUR "+murID);
	  return;
	  }
       if(isUpdate) {
           newRxThrMap[stream][thisID]=new String(data);
	   update=true;
	   }
       else rxThrMap[stream][thisID]=new String(data);
       }

    public String getRxThrData(String sn, int stream, boolean useUpdateValue) {
       if(!snMap.containsKey(sn)) {
          System.err.println(sn+" not in snMap for MUR "+murID);
	  return null;
	  }
       String id = (String)snMap.get(sn);
       int thisID = Integer.valueOf(id).intValue();
       thisID--;  // thisID is 1 to 6
       return useUpdateValue ? newRxThrMap[stream][thisID] : rxThrMap[stream][thisID];
       }
    public boolean isUpdated() {
       return update;
       }
    public String getModuleID(String sn) {
       if(!snMap.containsKey(sn)) return null;
       return (String)snMap.get(sn);
       }
    public String getSerialno(String id) {
       int index = Integer.valueOf(id).intValue();
       index--;
       return serialnos[index];
       }

}
