///////////////////////////////////////////////////////////////////////////
// This file contains the class definition to issue 
// a non-transition command (inspired from DDC code package)
//					
//    Created 01.04.03
//    by A. Abdesselam
///////////////////////////////////////////////////////////////////////////

#ifndef _SCTDDCCOMMANDSENDER_H_
#define _SCTDDCCOMMANDSENDER_H_

#include <string>

#ifndef _DDCCOMMAND_H_
#warning Send a mail to S. Khomoutnikov, author of online-00-22-00/installed/include/ddc/DdcCommand.hxx requiring him to put std::string everywhere!!
using namespace std;  // Needed because the online headers don't have it!!!
#include "ddc/DdcCommand.hxx"
#endif


class SCTDdcCommandSender
{
public:
  //constructor
  SCTDdcCommandSender(IPCPartition& partition, std::string** ctrlList); 
 
  //destructor
  ~SCTDdcCommandSender();
  
  int ddcSendCommand(std::string& commandName, 
		     std::string& commParameters, unsigned int timeout);
  int ddcSendCommand(std::string ctrlName, std::string& commandName, 
		      std::string& commParameters, unsigned int timeout);
  bool ddcRemoveCommand();
  bool ddcRemoveCommand(std::string& ctrlName);
  std::string  makeResponseName(std::string& ctrlName, std::string& commandName);
  
  //get methods
  int decreaseCtrlNum(){ return(--m_ctrlNum);}
  IPCPartition&	getPartition(){ return(m_partition);}
  std::string& getCommand(){ return(m_commandName);}
  ISInfoReceiver* getReceiver(){ return(m_receiver);}
  bool commandAllowed(){return m_commandAllowed;}

  //set methods
  void setCommandAllowedTrue(){m_commandAllowed = true;}
  void setCommandResponse(int commandResp){m_commandResponse = commandResp;}

private:
  bool isValidCtrl(std::string& name);
  bool __ddcSendCommand(std::string& isEntryName, std::string& commandName, 
			std::string& commParameters, unsigned int timeout);
  
  IPCPartition	        m_partition;
  time_t		m_startTime;
  std::string		m_commandName;
  ISInfoReceiver*       m_receiver;
  bool			m_commandAllowed;
  int                    m_commandResponse;
  int			m_ctrlNum;
  unsigned int            m_timeout;
  std::string**		m_controllers;
};

#endif // _SCTDDCCOMMANDSENDER_H_

